/* - Local libraries;
libname CRSPA "F:\New Data\CRSP\sasdata\q_stock";  				* used for smaller CRSP and Compustat for laptop (citoof year:2000);
libname CompA "F:\New Data\comp\nam";
libname IVBProj "D:\Fama Macbeth\SAS Works\IVBetaProjFF3";
* libname TAQProj "E:\Joonki Data Folder\SAS Works\TAQProj";
* libname EHDCRSP "D:\Fama Macbeth\RawData\CRSP";	
libname EHDCRSP "F:\New Data\CRSP\sasdata\q_stock";
libname EHDComp "D:\Fama Macbeth\RawData\Compustat";		*full CRSP and Compustat;
libname FF "F:\New Data\ff\sasdata";		* libname FRB "E:\RawData\FRB";		
%let serverID = 2;
*/

%let CRSPCutYr = 1952; 
%let DimsonT_Th = 1;

* - Local libraries;
libname CRSPA "F:\crsp";  				* used for smaller CRSP and Compustat for laptop (citoof year:2000);
libname CompA "F:\compstat";
libname IVBProj "C:\Users\Desktop\Kuntara";
* libname TAQProj "E:\Joonki Data Folder\SAS Works\TAQProj";
* libname EHDCRSP "D:\Fama Macbeth\RawData\CRSP";	
*libname EHDCRSP "F:\New Data\CRSP\sasdata\q_stock";
*libname EHDComp "D:\Fama Macbeth\RawData\Compustat";		*full CRSP and Compustat;
libname FF "F:\ff";		* libname FRB "E:\RawData\FRB";		
%let serverID = 2;



proc datasets nowarn nolist nodetails library=work kill; run; quit;

* The following can be created as a single document;

%let RBLeng1=3;
%let RetdCntCut = 200;


* Loading monthly CRSP data;
data CRSP_Mon_Tab; set IVBProj.CRSP_CCM_Comp_Mon_Tab; 
	keep permno date ret rf Sizem Mom6 B2M B2M; run;

proc sort data=CRSP_Mon_Tab; by date permno; run;
data CRSP_Mon_Tab_Ch; set CRSP_Mon_Tab; by date; if first.date; run;

************************************************;
** - Combining IVBetas and Monthly CRSP data   *;
************************************************;

* FF3;
proc sql; 
	create table CRSPm_FinTab_RBd_FF3 (drop=Npermno Ndate) as select *
	from CRSP_Mon_Tab as a,
		 IVBProj.CRSPd_RBetas_cap (rename=(permno=Npermno date=Ndate)) as b
	where a.permno = b.Npermno and year(a.date) = year(b.Ndate) and
		  month(a.date) = month(b.Ndate); quit;
proc sort data=CRSPm_FinTab_RBd_FF3; by permno date; run;
data IVBProj.CRSPm_FinTab_RBd_cap_&RBLeng1._&RetdCntCut; set CRSPm_FinTab_RBd_FF3; run;


* Define FBOLS variables to match the coding the GetMacros_IVB_Rep_org.sas;

data CRSPm_FinTab_RBd_FF3;
set CRSPm_FinTab_RBd_FF3;
mktrf_FBOLS=mktrf_FM;
if year(date)<2013 and year(date)>1986;
run;



%Include "C:\Users\zghtc\Desktop\Kuntara RA\KuntaraGetMacros_IVB_Rep_org.sas";

***********************************************; 
***********************************************; * We are using the Excess returns!!;
* - Running Fama-MacBeth Regressions    	  *; * Based on rolling betas;
*   with CRSP Monthly + Time-varying IVBetas  *; * No need for One-month bias correction for FM;
***********************************************;
** - Defining the Macro Variables;
**   Risk Factors;
data Reg_varname_Mon_Ind; length Vname $50 Vname_suffix $10; input Vname $ Vname_suffix $;
	datalines;
	MKTRF _Coef

	MKTRF_FBOLS _Coef

; run; 
**   Characteristics (One-month Lagged); 
data Reg_varname_Mon_Ind_Chars; length Vname $100 Vname_suffix $20; input Vname $ Vname_suffix $;
	datalines;
	Sizem_1 _Coef
	B2M_1 _Coef
	Mom6 _Coef	
; run; 
* Mom6 is already delayed in its construction;


**************;
*** - FF3	 *;
**************;
** 1. IVFM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(1),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist; 
%DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3);
%RunIVXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,
			  Regressors=&Vnamelist &CVnamelist,EndoVars=&Vnamelist,IVs=&IVnamelist,Outdname=XR_Ind_FF3_D_IV);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IV,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	

* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=5,Outdname=XR_Ind_FF3_D_IVT);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 
	
%GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist, NLag=36);

%RunIVXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,
			  Regressors=&Vnamelist,EndoVars=&Vnamelist,IVs=&IVnamelist,Outdname=XR_Ind_FF3_D_IV);

* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=5,Outdname=XR_Ind_FF3_D_IVT);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist,coeflist=&Cnamelist,reglist=&Rnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist,coeflist=&Cnamelist,reglist=&Rnamelist,JWOpt=0); 	
%GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist, NLag=36);

** 3. Char included;


proc sort data=CRSPm_FinTab_RBd_FF3; by date permno; run;



proc model data=CRSPm_FinTab_RBd_FF3 NOPRINT;
   exogenous MKTRF_IV
             B2M_1 Sizem_1;
   by date;
   parms a0-a3;
   MKTRF = a0+a1*MKTRF_IV+a2*B2M_1+a3*Sizem_1;
   fit  MKTRF / ols outest=IV_chars_in_MKTRF;
run;


proc sql;
create table mktrffit as select * 
from CRSPm_FinTab_RBd_FF3 as a, IV_chars_in_MKTRF as b
where a.date=b.date;
quit;



data mktrffit (keep=permno date MKTRFfitted);
set mktrffit;
MKTRFfitted=a0+a1*MKTRF_IV+a2*B2M_1+a3*Sizem_1;
run;



proc sql;

create table CRSPm_FinTab_RBd_FF3_fit as select *
from CRSPm_FinTab_RBd_FF3 as a, mktrffit as b
where a.permno=b.permno and a.date=b.date;

quit;


proc sort data=CRSPm_FinTab_RBd_FF3_fit; by date permno; run;


proc sort data=CRSPm_FinTab_RBd_FF3_fit; by date permno; run;

proc model data=CRSPm_FinTab_RBd_FF3_fit NOPRINT;
   exogenous mktrffitted
           Sizem_1 B2M_1;
   by date;
   parms gamma0-gamma5;
   ret =gamma0+gamma1*mktrffitted+gamma2*Sizem_1+gamma3*B2M_1;
   fit  ret / ols outest=IV_chars_in;
run;



proc sort data= IV_chars_in; by date; run;


data XR_Ind_FF3_D_IV;
set IV_chars_in;
intercept=gamma0;
mktrf=gamma1;
sizem_1=gamma2;
B2M_1=gamma3;
run;

/*proc model data=IV_chars_in;
         endo gamma0-gamma5;
         instruments intercept;
         parms coeffgamma0-coeffgamma5; 
	     eq.h1 = coeffgamma0 - gamma0;
         eq.h2 = coeffgamma1 - gamma1;
	     eq.h3 = coeffgamma2 - gamma2;
         eq.h4 = coeffgamma3 - gamma3;  
         eq.h5 = coeffgamma4 - gamma4;
	     eq.h6 = coeffgamma5 - gamma5;
         fit h1-h6 / gmm kernel=(bart,0,0) vardef=n outest=Risk_premium_IV_chars_in covout;
run;*/


* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=5,Outdname=XR_Ind_FF3_D_IVT);
* %GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0);
%GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist, NLag=36);



proc model data=CRSPm_FinTab_RBd_FF3_fit NOPRINT;
   exogenous mktrffitted;
   by date;
   parms gamma0-gamma1;
   ret =gamma0+gamma1*mktrffitted;
   fit  ret / ols outest=IV_chars_in;
run;



proc sort data= IV_chars_in; by date; run;


data XR_Ind_FF3_D_IV;
set IV_chars_in;
intercept=gamma0;
mktrf=gamma1;
run;

/*proc model data=IV_chars_in;
         endo gamma0-gamma5;
         instruments intercept;
         parms coeffgamma0-coeffgamma5; 
	     eq.h1 = coeffgamma0 - gamma0;
         eq.h2 = coeffgamma1 - gamma1;
	     eq.h3 = coeffgamma2 - gamma2;
         eq.h4 = coeffgamma3 - gamma3;  
         eq.h5 = coeffgamma4 - gamma4;
	     eq.h6 = coeffgamma5 - gamma5;
         fit h1-h6 / gmm kernel=(bart,0,0) vardef=n outest=Risk_premium_IV_chars_in covout;
run;*/


* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=5,Outdname=XR_Ind_FF3_D_IVT);
* %GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist,coeflist=&Cnamelist,reglist=&Rnamelist,JWOpt=0); 
%GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist, NLag=36);




** 2. Standard FM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(2),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist;  
* %DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3); *Do not need to delay it twice;
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=&Vnamelist &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0);


** 2. Standard FM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(2),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist;  
* %DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3); *Do not need to delay it twice;
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=&Vnamelist,Outdname=XR_Ind_FF3_D);
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D,varlist=&Vnamelist,coeflist=&Cnamelist ,reglist=&Rnamelist ,JWOpt=0);




*Added by Zhujin Guo;
* Hansen and Hodrick corrections for mean-estimator;
%Macro GetHansenHodrickCorrectionZhujin(dname=,varlist=,NLag=);
/*
%let dname=XR_Ind_FF3_D_IVTF;				%let varlist=&Vnamelist &CVnamelist;
%let NLag = 36;
*/
data &dname._tmp; set &dname; keep Intercept &varlist; run;  
%if &VarN = 1 %then %do;
data &dname._tmp; retain Intercept &varlist;
	set &dname._tmp; where cmiss(MKTRF_FBOLS)=0; run; %end;
%if &VarN = 3 %then %do;
data &dname._tmp; retain Intercept &varlist;
	set &dname._tmp; where cmiss(MKTRF_FBOLS,SMB_FBOLS,HML_FBOLS)=0; run; %end;
proc iml;
	use &dname._tmp; read all into OLS;  *T by K;
	T = nrow(OLS);			K = ncol(OLS);	
	X = J(T,1,1);						*T by 1;
	Slope = inv(t(X)*X)*t(X)*OLS;		*1 by K;
	u = OLS - X*Slope;					*T by K;
	D = inv(t(X)*X/T);
	se = J(K,1,0);

	* For each slope, compute SE of HH and NW;
	do ij=1 to K;
		err = X#u[,ij];					*T by 1;
		V = t(err)*err/T;
		do ihh=1 to &NLag;
			S = t(err[1:T-ihh,])*err[1+ihh:T,]/T;
			V = V + (1-0*ihh/(&NLag+1))*(S+t(S));
		end;
		se[ij] = sign(1/T*D*V*D)*sqrt(abs(1/T*D*V*D));
	end;
	tVal = t(Slope)/se;

	* Combining slopes and their SEs;
	&dname._hhcFM_Est_tmp = t(Slope) || se || tVal;
	create work.&dname._hhcFM_Est_tmp var{Estimate StdErr tValue}; 
	append from &dname._hhcFM_Est_tmp; 
quit;
data &dname._hhcFM_Est; 
	merge &dname._nwcFM_Est (keep=Parameter) &dname._hhcFM_Est_tmp; run;
/* proc sql; create table &dname._hhcFM_Est as select *
	from &dname._nwcFM_Est_tmp as a, &dname._hhcFM_Est_tmp as b where 1; quit;*/
data &dname._hhcFM_Est; set &dname._hhcFM_Est;
	Estimate = round(Estimate,0.00001);
	StdErr = round(StdErr,0.00001);
	TValue = round(TValue,0.001); run;
proc datasets lib=work; delete &dname._tmp &dname._hhcFM_Est_tmp; quit;
%MEND GetHansenHodrickCorrectionZhujin;

	
%GetHansenHodrickCorrectionZhujin(dname=XR_Ind_FF3_D,varlist=&Vnamelist &CVnamelist, NLag=36);	
*%GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D,varlist=&Vnamelist &CVnamelist, NLag=36);

proc univariate data=Xr_ind_ff3_d_iv_nstock; 
var nstock; 
run;
